/*
 * This code is based on the code from OpenIRCd.
 *
 * $Id: channel_forward.c,v 3.6 2004/10/03 00:34:38 nenolod Exp $
 */

#include "stdinc.h"
#include "tools.h"
#include "channel.h"
#include "channel_mode.h"
#include "client.h"
#include "common.h"
#include "hash.h"
#include "irc_string.h"
#include "ircd.h"
#include "list.h"
#include "numeric.h"
#include "s_serv.h"		/* captab */
#include "s_user.h"
#include "send.h"
#include "whowas.h"
#include "s_conf.h"		/* ConfigFileEntry, ConfigChannel */
#include "event.h"
#include "memory.h"
#include "balloc.h"
#include "resv.h"

void
do_forward (struct Client *source_p, char *name)
{
  struct Channel *chptr;

  chptr = get_or_create_channel (source_p, name, NULL);

  if (!IsMember (source_p, chptr))
    {
      add_user_to_channel (chptr, source_p, 0);
      if (chptr->chname[0] != '&')
	{
	  sendto_server (NULL, CAP_TS6, NOCAPS,
			 ":%s SJOIN %lu %s +nt :%s", me.id,
			 (unsigned long) chptr->channelts, chptr->chname,
			 source_p->id);
	  sendto_server (NULL, NOCAPS, CAP_TS6,
			 ":%s SJOIN %lu %s +nt :%s", me.name,
			 (unsigned long) chptr->channelts, chptr->chname,
			 source_p->name);
	}
      sendto_channel_local (ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
			    source_p->name, source_p->username,
			    GET_CLIENT_HOST (source_p), chptr->chname);

      if (chptr->topic != NULL)
	{
	  sendto_one (source_p, form_str (RPL_TOPIC), me.name,
		      source_p->name, chptr->chname, chptr->topic);
	  sendto_one (source_p, form_str (RPL_TOPICWHOTIME),
		      me.name, source_p->name, chptr->chname,
		      chptr->topic_info, chptr->topic_time);
	}

      source_p->localClient->last_join_time = CurrentTime;
      channel_member_names (source_p, chptr, 1);
    }
}
